<?php
   include "dayadb.php";
   /* include ITX */
   include_once $pear_tmpl;
   include_once $pear_db;

   /* check if user logged in */
   if (isset($_SESSION["memberID"]))
   {
      /* check if this is time out */
      if (isTimeOut())
      {
         header("Location: timeout.php");
      }

   /* Template */
   $template = new HTML_Template_ITX("./templates");
   $template->loadTemplatefile("history.tpl", true, true);

   /* connection to database */
   $connection = DB::connect($login);

   /* check db error */
   if (DB::isError($connection))
   {
      die($connection->getMessage());
   }

 /* include header banner php file */
   include "login.php";
   include "head.php";
   include "categories.php";
   include "search.php";
   include "top5members.php";
   include "footer.php";
 /* end include */

   /* query the bid process for the member */
   $query = "SELECT t.itemID, i.brand_title, t.finalPrice, t.sellerID,
                    m.userName, i.addDate, i.biddingPeriod
             FROM transaction t, transactionDetail td, member m, items i
             WHERE t.itemID = i.itemID AND t.sellerID = m.memberID
                   AND t.transactionID = td.transactionID
                   AND t.completion = 'Y'
                   AND t.tdelete = 'N' AND td.tddelete = 'N' 
                   AND i.idelete = 'N' AND m.mdelete = 'N'
                   AND td.buyerID = " . $_SESSION["memberID"] .
             " GROUP BY td.transactionID, td.buyerID";

   /* get the result */
   $result = $connection->query($query);
   /* check if query error */
   if (DB::isError($result))
   {
      die($result->getMessage());
   }

   /* count total bid record */
   $bidcount = $result->numRows();

   /* free the memrory */
   $result->free();

   $bidoffset = 0;
   /* retrieve the bid offset value */
   if (isset($_GET["bidoffset"]))
   {
      $bidoffset = $_GET["bidoffset"];
   }

   /* limit the number of rows */
   $result = $connection->limitQuery($query, $bidoffset, LIMITROWS);

   /* retrieve the number of bid row count and current row */
   $template->setCurrentBlock("BIDPAGECOUNT");
   if ($bidcount > 0)
   {
      $template->setVariable("CBIDRECORD", $bidoffset + 1);
   }
   else
   {
      $template->setVariable("CBIDRECORD", $bidoffset);
   }
   $template->setVariable("TOTALBIDRECORD", $bidcount);
   $template->parseCurrentBlock("BIDPAGECOUNT");

   $rowcount = 0;
   /* check if there is any result */
   if ($bidcount > 0)
   {
      while ($row = $result->fetchrow(DB_FETCHMODE_ASSOC))
      {
         $template->setCurrentBlock("MEMBERBIDPROCESS");
         $template->setVariable("ITEMID", $row["itemID"]);
         $template->setVariable("ITEMTITLE", $row["brand_title"]);
         $template->setVariable("PRICE", $row["finalPrice"]);
         $template->setVariable("MEMBERID", $row["sellerID"]);
         $template->setVariable("MEMBER", $row["userName"]);
         $template->parseCurrentBlock("MEMBERBIDPROCESS");
         $rowcount++;
      }
   }

   /* set bid page navigation */
   $template->setCurrentBlock("BIDPAGENAVIGATE");
   /* if there is any previous page */
   if ($bidoffset-LIMITROWS >= 0)
   {
      $tmpoffset = $bidoffset - LIMITROWS;
      $template->setVariable("BIDPREVIOUS", "?bidoffset={$tmpoffset}");
   }
   else
   {
      $template->setVariable("BIDPREVIOUS", "#");
   }

   /* if there is any next page? */
   if ($bidoffset+LIMITROWS < $bidcount)
   {
      $tmpoffset = $bidoffset + LIMITROWS;
      $template->setVariable("BIDNEXT", "?bidoffset={$tmpoffset}");
   }
   else
   {
      $template->setVariable("BIDNEXT", "?bidoffset={$bidoffset}");
   }
   $template->parseCurrentBlock("BIDPAGENAVIGATE");

   /* free the memrory */
   $result->free();
  
   /* construct query for retriving number of rows and the records */
   $query = "SELECT i.itemID, i.brand_title, t.buyerID, m.userName,  
                    i.addDate, i.biddingPeriod, t.finalPrice
             FROM items i, transaction t LEFT JOIN member m
             ON t.buyerID = m.memberID
             WHERE i.itemID = t.itemID
                   AND t.completion = 'Y'
                   AND t.tdelete = 'N' AND i.idelete = 'N' 
                   AND i.sellerID = " . $_SESSION["memberID"];

   /* get the result */
   $result = $connection->query($query);
   /* check if query error */
   if (DB::isError($result))
   {
      die($result->getMessage());
   }

   /* retrieve row count from sell records */
   $sellcount = $result->numRows();

   /* free memory */
   $result->free();

   /* initial the sell offset value to 0 */
   $selloffset = 0;
   /* retrieve the offset value */
   if (isset($_GET["selloffset"]))
   {
      $selloffset = $_GET["selloffset"];
   }

   /* limit the number of rows */
   $result = $connection->limitQuery($query, $selloffset, LIMITROWS);

   /* check if query error */
   if (DB::isError($result))
   {
      die($result->getMessage());
   }

   /* set the total number of records and the current records */
   $template->setCurrentBlock("SELLPAGECOUNT");
   if ($sellcount > 0)
   {
      $template->setVariable("CSELLRECORD", $selloffset + 1);
   }
   else
   {
      $template->setVariable("CSELLRECORD", $selloffset);
   }
   $template->setVariable("TOTALSELLRECORD", $sellcount);
   $template->parseCurrentBlock("SELLPAGECOUNT");

   /* set row count to 0 */
   $rowcount = 0;
   /* check if there is any record */
   if ($result->numRows() > 0)
   {
      while ($row = $result->fetchrow(DB_FETCHMODE_ASSOC))
      {
         $template->setCurrentBlock("MEMBERSELLPROCESS");
         $template->setVariable("ITEMID", $row["itemID"]);
         $template->setVariable("ITEMTITLE", $row["brand_title"]);
         $template->setVariable("PRICE", $row["finalPrice"]);
         $template->setVariable("MEMBERID", $row["buyerID"]);
         $template->setVariable("MEMBER", $row["userName"]);
         $template->parseCurrentBlock("MEMBERSELLPROCESS");
         $rowcount++;
      }
   }

   /* deal with sell page navigation */
   $template->setCurrentBlock("SELLPAGENAVIGATE");
   /* if there is next page ? */
   if ($selloffset-LIMITROWS >= 0)
   {
      $tmpoffset = $selloffset - LIMITROWS;
      $template->setVariable("SELLPREVIOUS", "?selloffset={$tmpoffset}");
   }
   else
   {
      $template->setVariable("SELLPREVIOUS", "#");
   }

   /* if there is previous page? */
   if ($selloffset+LIMITROWS < $sellcount)
   {
      $tmpoffset = $selloffset + LIMITROWS;
      $template->setVariable("SELLNEXT", "?selloffset={$tmpoffset}");
   }
   else
   {
      $template->setVariable("SELLNEXT", "?selloffset={$selloffset}");
   }
   $template->parseCurrentBlock("SELLPAGENAVIGATE");

   /* free the memory */
   $result->free();

   /* flush to screen */
   $template->show();  

   }
   else
   {
      header("Location: timeout.php");
      exit;
   }

?>
