<?php
//No. of rows to display on one page
$MAX_ROWS = 15;
$searchErrorOccured = false;

//Start of search queries
//Simple search query
$simpleQuery = "SELECT i.itemID, i.brand_title, i.addDate, i.biddingPeriod, 
i.price, m.userName, m.memberID FROM items i, member m WHERE 
i.sellerID = m.memberID AND i.idelete = 'N' AND
date_add(i.addDate, interval i.biddingPeriod day) > now() AND 
i.brand_title LIKE '%###%' LIMIT ??, $MAX_ROWS";

//Simple count query
$countQuery = "SELECT count(i.brand_title) FROM items i WHERE 
date_add(i.addDate, interval i.biddingPeriod day) > now() AND
i.idelete = 'N' AND i.brand_title LIKE '%###%'";

//Item detail query
$detailQuery = "SELECT i.brand_title, i.addDate, i.biddingPeriod, i.price, 
i.description, i.stock, m.userName FROM items i, member m WHERE 
i.sellerID = m.memberID AND i.idelete = 'N' AND i.itemID = '###'";

//Member Query 1 - Query returns member details 
$memberQuery1 = "SELECT m.userName, m.region, m.email, m.ranking 
FROM member m WHERE m.mdelete = 'N' AND m.memberID = '###'";

//member detail query - 2 - Query determines the no. of items brought on
//auction
$memberQuery2 = "SELECT count(t.buyerID) FROM member m, transaction t WHERE 
m.memberID = t.buyerID AND t.completion = 'Y' AND m.memberID = '###' GROUP BY 
t.buyerID";

//member detail query - 3 - Query determines the no. of items sold in auction
$memberQuery3 = "SELECT count(t.sellerID) FROM member m, transaction t WHERE 
m.memberID = t.sellerID AND t.completion = 'Y' AND m.memberID = '###' GROUP BY 
t.sellerID";

//member detail query - 4 - Query determines the no. of items curretly on auction
$memberQuery4 = "SELECT count(i.sellerID) FROM items i, member m WHERE 
m.memberID = i.sellerID AND m.memberID = '###' AND i.idelete = 'N' AND
date_add(i.addDate, interval i.biddingPeriod day) > now()
GROUP BY i.sellerID";

//base advanced query
$advQuery = "SELECT i.itemID, i.brand_title, i.addDate, i.biddingPeriod, 
i.price, 
m.userName, m.memberID FROM items i, member m, subCategory s, 
category c WHERE i.sellerID = m.memberID AND i.subCategoryID = s.subCategoryID 
AND c.categoryID = s.categoryID AND i.idelete = 'N' AND
date_add(i.addDate, interval i.biddingPeriod day) > now()";

//base advanced query count
$advQueryCount = "SELECT count(i.itemID) FROM items i, member m, subCategory s, 
 category c WHERE i.sellerID = m.memberID AND i.subCategoryID = 
s.subCategoryID AND c.categoryID = s.categoryID AND i.idelete = 'N' AND 
date_add(i.addDate, interval i.biddingPeriod day) > now()";

//End of Search Queries
//Function checks if simple search input is empty or null
function checkVar($var, $varTxt)
{  
   Global $searchErrorMsg;
   Global $searchErrorOccured;
   //check if search field is set or empty
   if (!isset($var) || empty($var))
   {
      //report an error has occured
      $searchErrorMsg =  " Nothing was entered in the $type field";
      $searchErrorOccured = true;

   }
}
/*function which conducts a simple search - from user input
$toSearch = user input (generally)
$queryLength = length of user input to accept
$query = Part or whole SQL query to use
*/
function doSimpleSearch ($toSearch, $queryLength, $query)
{ 
	Global $connection;
   Global $search;
   Global $MAX_ROWS;
   Global $login;
   Global $searchErrorMsg;
   Global $searchErrorOccured;

   if (!$searchErrorOccured)
   {
      if ($toSearch == "")
      {
         $toSearch = $_SESSION["toSearch"];
      }
      else
      {
         //check that input is clean for the database query
         $toSearch = mysqlclean($toSearch, $queryLength, $connection->connection);
         //assign search string to session variable for tracking current search
         $_SESSION["prevSearch"] = $_SESSION["toSearch"];
         $_SESSION["toSearch"] = $toSearch;
      }
      //replace searchString place holder with requested search string
      $searchQuery = str_replace("###", $toSearch, $query);
      // check if first results page or greater and set Start row of search
      if (isset($_SESSION["pageNo"]))
      {
         $startRow = ($_SESSION["pageNo"]-1)*$MAX_ROWS;
      }
      else
      {
         $startRow = 0;
      }
      //replace stat row place holder with actual start row for search
      $searchQuery = str_replace("??", $startRow, $searchQuery);
      // track prev search for debug
      $_SESSION["oldSearchString"] = $_SESSION["searchString"];
      // record current search string for debug
      $_SESSION["searchString"] = $searchQuery;
      
      //for query debug checking - comment out in production version
      //writeToFile($searchQuery);
      //run search query on db
      $search = $connection->query($searchQuery);
      if (DB::isError($search))
      {
         //report an error has occured
         $searchErrorMsg =  "Sorry a database error occured - ".($search->getMessage());
         $searchErrorOccured = true;
      } 
      else
      {
         return $search;
      }
   }
}
/*
Function to parse the search results to the search results template
*/
function parseSearch()
{
   Global $template;
   Global $search;
   Global $MAX_ROWS;
   Global $searchErrorMsg;
   Global $searchErrorOccured;

   if (!$searchErrorOccured)
   {
      $template->addBlockFile("SEARCH_RESULTS", "results", "result.tpl");
      // determine if any search results.
      if ($_SESSION["rows"] > 0)
      {
         $template->setCurrentBlock("result_num");
         $template->setVariable("NUMROWS",$_SESSION["rows"]);
         $template->parseCurrentBlock("result_num");
         //loop through the search data and add
         while ($row = $search->fetchRow(DB_FETCHMODE_ASSOC))
         {
            $timeLeft = getTime($row["addDate"],$row["biddingPeriod"]);
            $template->setCurrentBlock("table");
            $template->setVariable("ITEMID", $row["itemID"]);
            $template->setVariable("ITEMTITLE", $row["brand_title"]);
            $template->setVariable("PRICE", $row["price"]);
            $template->setVariable("TIMELEFT", $timeLeft);
            $template->setVariable("MEMBERID", $row["memberID"]);
            $template->setVariable("MEMBER", $row["userName"]);
            $template->parseCurrentBlock("table");
         }
         //add prev / next links if needed - checks rows to determine.
         if ($_SESSION["rows"] > $MAX_ROWS)
         {          
            if (($_SESSION["rows"] - ($_SESSION["pageNo"]*($MAX_ROWS-1)))>0 && 
   ($MAX_ROWS*$_SESSION["pageNo"])<$_SESSION["rows"])
            {
               //if more results display next link
               $template->setCurrentBlock("next");
               $template->setVariable("NEXT",$_SERVER["PHP_SELF"]."?page="
               .($_SESSION["pageNo"]+1));
               $template->parseCurrentBlock("next");
            }
            if ($_SESSION["pageNo"]>1)
            {
               //if previous pages display previous link
               $template->setCurrentBlock("prev");
               $template->setVariable("PREVIOUS",$_SERVER["PHP_SELF"]."?page="
               .($_SESSION["pageNo"]-1));
               $template->parseCurrentBlock("prev");
            }
         }
      }
      else
      {
         //report that no matching results found
         $searchErrorMsg =  " No records match the search criteria";
         $searchErrorOccured = true;
      }
   }
}
//Function to parse Item detail search results to search template
function parseDetail()
{
   Global $template;
   Global $search;
   Global $searchErrorMsg;
   Global $searchErrorOccured;

   if (!$searchErrorOccured)
   {
      //load result Block file
      $template->addBlockFile("SEARCH_RESULTS", "results", "detail.tpl");
      // determine if any search results. ie false itemID sent
      if ($_SESSION["rows"] > 0)
      {
         $row = $search->fetchRow(DB_FETCHMODE_ASSOC);
         $template->setCurrentBlock("brand_title");
         $template->setVariable("BRAND_TITLE",$row["brand_title"]);
         $template->parseCurrentBlock("brand_title");

         $template->setCurrentBlock("stock");
         $template->setVariable("STOCK",$row["stock"]);
         $template->parseCurrentBlock("stock");

         $template->setCurrentBlock("description");
         if (empty($row["description"]))
         {
            $row["description"]="No description provided";
         }
         $template->setVariable("DESCRIPTION",$row["description"]);
         $template->parseCurrentBlock("description");
         
         $timeLeft = getTime($row["addDate"],$row["biddingPeriod"]);

         $template->setCurrentBlock("timeleft");
         $template->setVariable("TIMELEFT",$timeLeft);
         $template->parseCurrentBlock("timeleft");

         $template->setCurrentBlock("username");
         $template->setVariable("USERNAME",$row["userName"]);
         $template->parseCurrentBlock("username");

         // set up a back link to the previous search page, and maintain the 
         //correct search string
         if (isset($_SESSION["toSearch"]))
         {
            //if simple search - set current search to previous search
            // NOT the item detail search!
            $_SESSION["toSearch"] = $_SESSION["prevSearch"];
         }
         $part_URI = 
   substr($_SERVER["REQUEST_URI"],0,strrpos($_SERVER["REQUEST_URI"],"/"));
         $URI = 
   "http://".$_SERVER['HTTP_HOST'].$part_URI."/searchresult.php?page="
   .$_SESSION["pageNo"];
         // define back link string (URI) for inclusion
         $backLink = $URI;

         $template->setCurrentBlock("back");
         $template->setVariable("BACK",$backLink);
         $template->parseCurrentBlock("back");
         
      }
      else
      {
         //report that no matching results found
         $searchErrorMsg =  " No items match the search criteria";
         $searchErrorOccured = true;
      }
   }
}

function parseMember()
{
   Global $template;
   Global $search1;
   Global $search2;
   Global $search3;
   Global $search4;
   Global $searchErrorMsg;
   Global $searchErrorOccured;

   if (!$searchErrorOccured)
   {
      //load result Block file
      $template->addBlockFile("SEARCH_RESULTS", "results", "result.tpl");
      // determine if any search results. ie false itemID sent
      if ($_SESSION["rows"] > 0)
      {
         $row = $search1->fetchRow(DB_FETCHMODE_ASSOC);
         $template->setCurrentBlock("username");
         $template->setVariable("USERNAME",$row["userName"]);
         $template->parseCurrentBlock("username");

         $template->setCurrentBlock("region");
         $template->setVariable("REGION",$row["region"]);
         $template->parseCurrentBlock("region");

         $template->setCurrentBlock("email");
         $template->setVariable("EMAIL",$row["email"]);
         $template->parseCurrentBlock("email");

         $template->setCurrentBlock("ranking");
         $template->setVariable("RANKING",$row["ranking"]);
         $template->parseCurrentBlock("ranking");
         
         $row = $search3->fetchRow(DB_FETCHMODE_DEFAULT);
         $template->setCurrentBlock("sales");
          if ($row[0]>=1)
         {
            $template->setVariable("SALES",$row[0]);
         }
         else
         {
            $template->setVariable("SALES",0);
         }
         $template->parseCurrentBlock("sales");

         $row = $search2->fetchRow(DB_FETCHMODE_DEFAULT);
         $template->setCurrentBlock("purchases");
         if ($row[0]>=1)
         {
            $template->setVariable("PURCHASES",$row[0]);
         }
         else
         {
            $template->setVariable("PURCHASES",0);
         }
         $template->parseCurrentBlock("purchases");
         
         $row = $search4->fetchRow(DB_FETCHMODE_DEFAULT);
         $template->setCurrentBlock("current");
         if ($row[0]>=1)
         {
            $template->setVariable("CURRENT",$row[0]);
         }
         else
         {
            $template->setVariable("CURRENT",0);
         }
         $template->parseCurrentBlock("current");

         // set up a back link to the previous search page, and maintain the 
         //correct search string
         if (isset($_SESSION["toSearch"]))
         {
            $_SESSION["toSearch"] = $_SESSION["membSearch"];
         }
         //if request is from the search page, add a back link if from top5 don't
         /* to be possibly implemented at a later date.
         if (!isset($HTTP_GET_VARS["top5"]))
         {
            $part_URI = 
      substr($_SERVER["REQUEST_URI"],0,strrpos($_SERVER["REQUEST_URI"],"/"));
            $URI = 
      "http://".$_SERVER['HTTP_HOST'].$part_URI."/searchresult.php?page="
      .$_SESSION["pageNo"];
            $backLink = $URI;
            $template->setCurrentBlock("back");
            $template->setVariable("BACK",$backLink);
            $template->parseCurrentBlock("back");
         }
         */
      }
      else
      {
         //report that no matching results found
         $searchErrorMsg =  " No members match the search criteria";
         $searchErrorOccured = true;
      }
   }
}

//Function to check if a new search is initiated
function checkNewSearch()
{
   Global $HTTP_GET_VARS;

   //check if a new search is started and unset session variables if true
   if (isset($HTTP_GET_VARS["searchSubmit"]) || 
   isset($HTTP_GET_VARS["advSearchSubmit"]) || 
   isset($HTTP_GET_VARS["subcategoryid"]) || 
   isset($HTTP_GET_VARS["memberid"]))
   {
      $_SESSION["pageNo"] = 1;

      if (isset($_SESSION["vars"]))
      {
         unset($_SESSION["vars"]);
      }
      if (isset($_SESSION["prevSearch"]))
      {
         unset($_SESSION["prevSearch"]);
      }
      if (isset($_SESSION["rows"]))
      {
         unset($_SESSION["rows"]);
      }
      if (isset($_SESSION["advSearch"]))
      {
         unset($_SESSION["advSearch"]);
      }
      if (isset($_SESSION["prevAdvSearch"]))
      {
         unset($_SESSION["prevAdvSearch"]);
      }
      if (isset($_SESSION["toSearch"]))
      {
         unset($_SESSION["toSearch"]);
      }
      if (isset($_SESSION["membSearch"]))
      {
         unset($_SESSION["membSearch"]);
      }
   }
}
//Function to check whether multiple result pages required
function pageCheck()
{
   Global $HTTP_GET_VARS;

   if (isset($HTTP_GET_VARS["page"]))
   {
      $_SESSION["pageNo"] = $HTTP_GET_VARS["page"];
      return true;
   }
   else
   {
      return false;
   }
}
//Function to determine the no. of rows from an SQL Count query
function getActiveRows()
{
   Global $search;
   if (!empty($search))
   {
      $row = $search->fetchRow(DB_FETCHMODE_DEFAULT);
      $_SESSION["rows"] = $row[0];
   }
}

//Function to determine the advanced search string, based on user input
function getAdvSearchString($advQuery, $HTTP_GET_VARS)
{
   Global $connection;

   //replace searchString place holders with appropriate get_vars
   //check subcategoryID search
   if (!empty($HTTP_GET_VARS["subcategoryid"]))
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["subcategoryid"], 20, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND i.subCategoryID = ".$toSearch;
   }
   //check itemName search
   if (!empty($HTTP_GET_VARS["itemtitle"]))
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["itemtitle"], 20, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND i.brand_title LIKE '%".$toSearch."%'";
   }
   //check price from search
   if (!empty($HTTP_GET_VARS["pricefrom"]))
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["pricefrom"], 10, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND i.price >= ".$toSearch;
   }
   //check price to search
   if (!empty($HTTP_GET_VARS["priceto"]))
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["priceto"], 10, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND i.price <= ".$toSearch;
   }
	//check category search
   if (!empty($HTTP_GET_VARS["category"]) && $HTTP_GET_VARS["category"] != 
"all")
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["category"], 50, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND c.categoryID = '".$toSearch."'";
   }
   //check subCategory search
   if (!empty($HTTP_GET_VARS["subcategory"]) && $HTTP_GET_VARS["subcategory"] 
!= 0)
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["subcategory"], 50, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND s.subCategoryID = '".$toSearch."'";
   }
   //check username search
   if (!empty($HTTP_GET_VARS["membername"]))
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["membername"], 20, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND m.userName LIKE '%".$toSearch."%'";
   }
   //check user region search
   if (!empty($HTTP_GET_VARS["region"]) && $HTTP_GET_VARS["region"] != "all")
   {
      //asssign variable to local var
      $toSearch = mysqlclean($HTTP_GET_VARS["region"], 30, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND m.region LIKE '%".$toSearch."%'";
   }
   //check rankfrom search
   if (!empty($HTTP_GET_VARS["rankfrom"]))
   {
      //clean user search input
      $toSearch = mysqlclean($HTTP_GET_VARS["rankfrom"], 2, 
$connection->connection);
      //add search request to Query
      $advQuery .= " AND m.ranking >= ".$toSearch;
   }
   
   if (!empty($HTTP_GET_VARS["daysleft"]) || !empty($HTTP_GET_VARS["hrsleft"]))
   {
      //check daysleft and clean user search input
      if (!empty($HTTP_GET_VARS["daysleft"]))
      {
         $days = mysqlclean($HTTP_GET_VARS["daysleft"], 2, 
         $connection->connection);
      } 
      else
      {
         $days = 0;
      }
      //check hrsleft and clean user search input
      if (!empty($HTTP_GET_VARS["hrsleft"]))
      {
         $hours = mysqlclean($HTTP_GET_VARS["hrsleft"], 2, 
         $connection->connection);
      } 
      else
      {
         $hours = 0;
      }
      //add search request to TimeQuery
      $advQuery .= " AND date_add(i.addDate, interval i.biddingPeriod day) 
      <= date_add(now(), interval '".$days." ".$hours."' DAY_HOUR)";
   }

   return $advQuery;
}
//Function to run the advanced search in the db and get results
//requires the part SQL query returned from getAdvSearchString
function doAdvSearch($advQuery)
{
   Global $search;
   Global $connection;
   Global $MAX_ROWS;
   Global $searchErrorMsg;
   Global $searchErrorOccured;

   if (!$searchErrorOccured)
   {
      if (isset($_SESSION["advSearch"]))
      {
         //track the current and previous search for debuging and other.
         $_SESSION["prevAdvSearch"] = $_SESSION["advSearch"];
      }
      $_SESSION["advSearch"] = $advQuery;

      // check if first results page or greater and set Start row of search
      if (isset($_SESSION["pageNo"]))
      {
         $startRow = ($_SESSION["pageNo"]-1)*$MAX_ROWS;
      }
      else
      {
         $startRow = 0;
      }
      //replace strat row place holder with actual start row for search
      $advQuery = str_replace("??", $startRow, $advQuery);
      // track prev search for debug
      $_SESSION["oldSearchString"] = $_SESSION["searchString"];
      // record current search string for debug
      $_SESSION["searchString"] = $advQuery;
      
      //for query debug checking - comment out in production version
      //writeToFile($advQuery);
      //run search query on db
      $search = $connection->query($advQuery);
      if (DB::isError($search))
      {
         $searchErrorMsg = "Sorry a database error occured - ".($search->getMessage());
         $searchErrorOccured = true;
      }
      else
      {
         return $search;
      }
   }
}


function writeToFile($query)
{
   $filename = "dayaQueryLog.Log";
   $toAdd = $query."\n\n";

   if (is_writable($filename)) 
   {
      if (!$handle = fopen($filename, 'a')) 
      {
         die("Cannot open file ($filename)");
      }
      if (!fwrite($handle, $toAdd)) 
      {
        die("Cannot write to file ($filename)");
      }
      fclose($handle);			
   } 
   else 
   {
    die("The file $filename is not writable");
   }
}

?>