<?php
   include "dayadb.php";
   /* include ITX */
   include_once $pear_tmpl;
   include_once $pear_db;

   /* Template */
   $template = new HTML_Template_ITX("./templates");
   $template->loadTemplatefile("itemDetail.tpl", true, true);


   /* connection to database */
   $connection = DB::connect($login);

   /* check db error */
   if (DB::isError($connection))
   {
      die($connection->getMessage());
   }

 /* include header banner php file */
   include "login.php";
   include "head.php";
   include "categories.php";
   include "search.php";
   include "top5members.php";
   include "footer.php";
 /* end include */ 

   /* construct a query for item detail */
   $query = "SELECT i.brand_title, i.description, i.stock, i.biddingPeriod,
                    i.addDate, i.price, m.userName, c.categoryName,
                    sc.subCategoryName, t.finalPrice, t.transactionID,
                    i.sellerID, t.buyerID, t.comments, t.completion
             FROM items i, member m, category c, subCategory sc,
                  transaction t
             WHERE i.itemID = " . $_GET["itemID"] . " AND
                   i.itemID = t.itemID AND i.sellerID = m.memberID
                   AND i.subCategoryID = sc.subCategoryID
                   AND sc.categoryID = c.categoryID";

   /* run query to retrieve records */
   $result = $connection->query($query);

   /* check if result error */
   if (DB::isError($result))
   {
      die($result->getMessage());
   }

   /* get records */
   $row = $result->fetchRow(DB_FETCHMODE_ASSOC);

    /* store necessary variable */
   $transactionid = $row["transactionID"];
   $timeleft = getTime($row["addDate"], $row["biddingPeriod"]);

   /* get buyer info */
   $buyername = "";
   if ($row["buyerID"] != NULL)
   {
      /* construct query for retriving latest buyer info */
      $querybuyer = "SELECT userName FROM member
                     WHERE memberID = " . $row["buyerID"];

      /* execute query to get buyer name */
      $resultbuyer = $connection->query($querybuyer);
      if (DB::isError($resultbuyer))
      {
         die($resultbuyer->getMessage());
      }

      $rowbuyer = $resultbuyer->fetchRow(DB_FETCHMODE_ASSOC);
      /* store buyer name */
      $buyername = $rowbuyer["userName"];
      /* free memory */
      $resultbuyer->free();
   }


   $template->setCurrentBlock("ITEMDETAIL");
   $template->setVariable("ITEMTITLE", $row["brand_title"]);
   $template->setVariable("CATEGORY", $row["categoryName"]);
   $template->setVariable("SUBCATEGORY", $row["subCategoryName"]);
   $template->setVariable("STOCK", $row["stock"]);
   $template->setVariable("SELLERID", $row["sellerID"]);
   $template->setVariable("SELLER", $row["userName"]);
   $template->setVariable("DESCRIPTION", $row["description"]);
   $template->setVariable("POSTPRICE", $row["price"]);
   $template->setVariable("CURRENTPRICE", $row["finalPrice"]);
   if (!empty($buyername))
   {
      $template->setVariable("BIDUSER", $buyername);
      $template->setVariable("BIDUSERID", $row["buyerID"]);
   }
   else
   {
      $template->setVariable("BIDUSER", "seller");
      $template->setVariable("BIDUSERID", $row["sellerID"]);
   }
   $template->setVariable("TIMELEFT", $timeleft);
   if (!empty($row["comments"]))
   {
      $template->setVariable("COMMENTS", $row["comments"]);
   }
   else
   {
      $template->setVariable("COMMENTS", "not yet set");
   }
   $template->parseCurrentBlock("ITEMDETAIL"); 


   /* check if this is logged in */
   if (isset($_SESSION["memberID"]))
   {
      /* if not expired, let member bid the item */
      if (strcmp($timeleft, "Expired") != 0)
      {
         $template->addBlockFile("POSTFORM", "bidform", "bidform.tpl");
         $template->setCurrentBlock("bidform");
         $template->setVariable("BUYER", $_SESSION["userName"]);
         $template->setVariable("CURRENTBID", $row["finalPrice"]);
         $template->setVariable("NEWPRICE", $row["finalPrice"]+1);
         $template->setVariable("TRANSACTIONID", $transactionid);
         $template->setVariable("ITEMID", $_GET["itemID"]);
         $template->parseCurrentBlock("bidform");
      }
      /* if expired, check if current member is last buyer of this item */
      else
      {
         /* if current member is last buyer and not yet comment
          *, let member give comment */
         if (($row["buyerID"] == $_SESSION["memberID"]) &&
                 ($row["completion"] == 'N'))
         {
            $template->addBlockFile("POSTFORM", "commentform",
                                                   "commentform.tpl");
            $template->setCurrentBlock("commentform");
            $template->setVariable("SELLERID", $row["sellerID"]);
            $template->setVariable("TRANSACTIONID", $transactionid);
            $template->parseCurrentBlock("commentform");
         }
      }
   }

   /* free memeory */
   $result->free();

   /* flush to screen */
   $template->show();  
  
?>
