<?php
   include "dayadb.php";
   /* include ITX */
   include_once $pear_tmpl;
   include_once $pear_db;

   /* check whether it is time out */
   if (isset($_SESSION["memberID"]))
   {
      if (isTimeOut())
      {
         header("Location: timeout.php");
         exit;
      }

   /* Template */
   $template = new HTML_Template_ITX("./templates");
   $template->loadTemplatefile("memberhome.tpl", true, true);

   /* connection to database */
   $connection = DB::connect($login);

   /* check db error */
   if (DB::isError($connection))
   {
      die($connection->getMessage());
   }

 /* include header banner php file */
   include "login.php";
   include "head.php";
   include "categories.php";
   include "search.php";
   include "top5members.php";
   include "footer.php";
 /* end include */

   /* set current user name */
   $template->setCurrentBlock("USER");
   $template->setVariable("USER", $_SESSION["fullname"]);
   $template->parseCurrentBlock("USER");

   /* query the bid process for the member */
   $query = "SELECT t.itemID, i.brand_title, t.finalPrice, t.sellerID,
                    m.userName, i.addDate, i.biddingPeriod
             FROM transaction t, transactionDetail td, member m, items i
             WHERE t.itemID = i.itemID AND t.sellerID = m.memberID
                   AND t.transactionID = td.transactionID
                   AND t.completion = 'N'
                   AND t.tdelete = 'N' AND td.tddelete = 'N' 
                   AND i.idelete = 'N' AND m.mdelete = 'N'
                   AND td.buyerID = " . $_SESSION["memberID"] .
             " GROUP BY td.transactionID, td.buyerID";

   /* get the result */
   $result = $connection->query($query);
   /* check if query error */
   if (DB::isError($result))
   {
      die($result->getMessage());
   }

   /* check if there is any result */
   if ($result->numRows() > 0)
   {
      while ($row = $result->fetchrow(DB_FETCHMODE_ASSOC))
      {
         $timeleft = getTime($row["addDate"], $row["biddingPeriod"]);
         $template->setCurrentBlock("MEMBERBIDPROCESS");
         $template->setVariable("ITEMID", $row["itemID"]);
         $template->setVariable("ITEMTITLE", $row["brand_title"]);
         $template->setVariable("PRICE", $row["finalPrice"]);
         $template->setVariable("MEMBERID", $row["sellerID"]);
         $template->setVariable("MEMBER", $row["userName"]);
         $template->setVariable("TIMELEFT", $timeleft);
         $template->parseCurrentBlock("MEMBERBIDPROCESS");
      }
   }

   /* free the memrory */
   $result->free();
  
   /* construct query for sell process */
   $query = "SELECT i.itemID, i.brand_title, t.buyerID, m.userName,  
                    i.addDate, i.biddingPeriod, t.finalPrice
             FROM items i, transaction t LEFT JOIN member m
             ON t.buyerID = m.memberID
             WHERE i.itemID = t.itemID 
                   AND t.completion = 'N'
                   AND t.tdelete = 'N' AND i.idelete = 'N' 
                   AND t.sellerID = " . $_SESSION["memberID"];

   /* query the database */
   $result = $connection->query($query);
   /* check if query error */
   if (DB::isError($result))
   {
      die($result->getMessage());
   }

   /* check if there is any record */
   if ($result->numRows() > 0)
   {
      while ($row = $result->fetchrow(DB_FETCHMODE_ASSOC))
      {
         $timeleft = getTime($row["addDate"], $row["biddingPeriod"]);
         $template->setCurrentBlock("MEMBERSELLPROCESS");
         $template->setVariable("ITEMID", $row["itemID"]);
         $template->setVariable("ITEMTITLE", $row["brand_title"]);
         $template->setVariable("PRICE", $row["finalPrice"]);
         $template->setVariable("MEMBERID", $row["buyerID"]);
         $template->setVariable("MEMBER", $row["userName"]);
         $template->setVariable("TIMELEFT", $timeleft);
         $template->parseCurrentBlock("MEMBERSELLPROCESS");
      }
   }

   /* free the memory */
   $result->free();

   /* flush to screen */
   $template->show();  

   }
   else
   {
      header("Location: timeout.php");
      exit;
   }

?>
