<?php
include_once("dayadb.php");
include_once($pear_tmpl);
include_once($pear_db);
include_once($inc_dir."searchFunctions.inc");


//check if a new search is started and unset session variables
checkNewSearch();
//connect to the database   
$connection = DB::connect($login);
if (DB::isError($connection))
{
   $searchErrorMsg = "Sorry a database error occured 1 - ".($connection->getMessage());
   $searchErrorOccured = true;
}

//Check for any errors
if (!$searchErrorOccured)
{
   
   //check where the request originated from - search or advance search
   if (isset($HTTP_GET_VARS["advSearchSubmit"]) || isset($HTTP_GET_VARS["subcategoryid"]))
   {
      //run advance search script
      //run count query without a limit to the query to determine total 
      //no of results
      $advQueryCount = getAdvSearchString($advQueryCount, $HTTP_GET_VARS);
      doAdvSearch($advQueryCount);
      if (!$searchErrorOccured)
      {
         getActiveRows();
      }
      //get the current user search request
      $advQuery = getAdvSearchString($advQuery, $HTTP_GET_VARS);
      //add page display limit to query
      $advQuery .= " LIMIT ??, $MAX_ROWS ";
      //run search
      doAdvSearch($advQuery);
      //show results
      //parseSearch();
   }
   else
   {
      //check if next or previous result page is requested
      if (isset($HTTP_GET_VARS["page"]))
      {
         $_SESSION["pageNo"] = $HTTP_GET_VARS["page"];
         //do database search for the next page of records
         if (isset($_SESSION["toSearch"]))
         {
            //simple search was run
            doSimpleSearch("","", $simpleQuery);
         }
         else
         {
            //advanced search was run
            doAdvSearch($_SESSION["advSearch"]);
         }
      }
      else
      {
         //check simple search
         checkVar($HTTP_GET_VARS["search"], "search");
         //do database search - count total queries
         doSimpleSearch($HTTP_GET_VARS["search"], 20, $countQuery);
         //get the total no. of matching queries
         if (!$searchErrorOccured)
         {
            getActiveRows();
         }
         //do search with a limit and full results
         doSimpleSearch($HTTP_GET_VARS["search"], 20, $simpleQuery);
      }
   }
}

//define new template
$template = new HTML_Template_ITX($template_dir);
$template->loadTemplatefile("searchresult.tpl", true, true);

if (!$searchErrorOccured && $_SESSION["rows"] > 0)
{
   //load result Block file if no errors
   parseSearch();
}
else
{
   if (!$_SESSION["rows"] > 0)
   {
      $searchErrorMsg = "No records match the search criteria";
   }
   //load error Block file
   $template->addBlockFile("SEARCH_RESULTS", "results", "error.tpl");
   $template->setCurrentBlock("message");
   $template->setVariable("MESSAGE",$searchErrorMsg);
   $template->parseCurrentBlock("message"); 
}
// Remainder of Templates

/* include header banner php file */
   include "login.php";
   include "head.php";
   include "categories.php";
   include "search.php";
   include "top5members.php";
   include "footer.php";
 /* end include */ 

/*$template->addBlockFile("HEADER", "header", "head.tpl");
$template->touchBlock("header");
$template->addBlockFile("LOGIN", "login", "login.tpl");
$template->touchBlock("login");
$template->addBlockFile("SEARCH", "search", "search.tpl");
$template->touchBlock("search");
$template->addBlockFile("FOOTER", "footer", "footer.tpl");
$template->touchBlock("footer");
flush to screen */

$template->show();  

?>